<?php
include_once('vendors/ProdaletTracker.php');

class shopProdaletPlugin extends shopPlugin
{
    const PLUGIN_NAME = 'prodalet';


    public function saveSettings($settings = array())
    {

        $plugin = waSystem::getInstance()->getPlugin(self::PLUGIN_NAME);
        $settingsOld = $plugin->getSettings();
        wa('site');
        $domains = siteHelper::getDomains(true);

        $data = array();

        foreach ($domains as $domain => $id)
        {

            if(!empty($settings['options']['domains'][$domain]['api_key']) and !empty($settings['options']['domains'][$domain]['api_secret']))
            {

                if (1 || empty($settingsOld['load_orders']['domains'][$domain])) {
                    $resLO = $plugin->addLastOrder($settings['options']['domains'][$domain]['api_key'], $settings['options']['domains'][$domain]['api_secret']);
                    if ($resLO) {
                        $settings['load_orders']['domains'][$domain] = 1;

                    }
                }

                if (empty($settingsOld['set_cart_url']['domains'][$domain])) {
                    $resSCU = $plugin->setCartUrl($settings['options']['domains'][$domain]['api_key'], $settings['options']['domains'][$domain]['api_secret']);
                    if ($resSCU) {
                        $settings['set_cart_url']['domains'][$domain] = 1;

                    }
                }
            }
        }

        parent::saveSettings($settings);
    }

    public static function isDbg()
    {
        return ProdaletTracker::isDbg();
    }

    private static function getProductImage($product_id)
    {
        $image = false;

        $m = new shopProductImagesModel();
        if ($url = $m->getImages($product_id, 'big', 'id', true)) {
            reset($url);
            $url = current($url);

            if (!empty($url['url_big'])) {
                $image = $url['url_big'];
            }
        }

        return $image;

    }


    public static function getProdaletUrl()
    {
        return self::getConfig('host');
    }

    public static function getConfig(string $key = null)
    {
        $value = wa()->getConfig()->getPluginInfo(self::PLUGIN_NAME);

        if (! empty($key)) {
            foreach (explode('.', $key) as $keyPrt) {
                $value = $value[$keyPrt] ?? null;
                if (! $value) {
                    break;
                };
            }
        }

        return $value;
    }

    /*public function order_update($params)
    {
        if (!$params['order_id']) return false;
        if (!($tracker = $this->_include_tracker_anonym())) return false;

        $order_id = $params['order_id'];
        if (!($order_data = $this->_getOrderData($order_id))) return false;

        $revenue = $order_data ? $order_data->revenue : null;
        $items = $order_data ? $order_data->items : null;

        $tracker->eventOrderUpdate($order_id, null, $revenue, $items);
    }

    public function order_state($params)
    {
        if (!$params['order_id']) return false;
        if (!($tracker = $this->_include_tracker_anonym())) return false;

        $order_id = $params['order_id'];

        $state = $this->_switchState($params['after_state_id']);

        $tracker->eventOrderUpdate($order_id, $state);
    }*/


    public function order_state($params)
    {

        if (!$params['order_id']) return false;
        if (!($tracker = $this->__add_tracker_wu())) return false;

        $order_id = $params['order_id'];
        if (!($order_data = $this->_getOrderData($order_id))) return false;

        $revenue = $order_data ? $order_data->revenue : null;
        $items = $order_data ? $order_data->items : null;
        $state = $this->_changeStatus($params['after_state_id']);

        $tracker->eventOrderUpdate($order_id, $state, $revenue, $items);
    }

    public function order_delete($params)
    {
        if (!$params['order_id']) return false;
        if (!($tracker = $this->__add_tracker_wu())) return false;

        $tracker->eventOrderUpdate($params['order_id'], 'cancelled');
    }


    /*
     * Функция восстановления корзины из ссылки, если перешли по ссылке "оформить заказ"
     * с другого устройства, отличного от того, где была сформированна корзина
     */
    public function setCart()
    {
        //Проверяем, что восстановление корзины нужно, только если в utm_source стоит prodalet
        $utm_source = waRequest::get('utm_source');
        if (!empty($utm_source) && ($utm_source == 'prodalet'))
        {

            if (waRequest::get('cart_items'))
            {
                //Идем по всем UTM-меткам в запросе и формируем массив $utm_data
                foreach (waRequest::get() as $k => $v) {
                    if (preg_match('~^utm_~ui', $k)) {
                        $___kkk = waRequest::get($k);
                        if (is_scalar($___kkk)) $utm_data[] = $k . '::' . $___kkk;
                    }
                }
                $utm_data = implode('|', $utm_data); //Все метки вормируем в единую строку

                if (!defined('FROM_PRODALET')) {
                    define('FROM_PRODALET', $utm_data);
                }

                //Если клиент перешел в магазин из нашего письма о брошенной корзине
                wa()->getResponse()->setCookie('lead_from_prodalet', $utm_data, time() + 60 * 60 * 24, null, '', false, true);


                $correct = array(); //Массив товаров из ссылки, который надо восстановить и добавить в текущую корзину пользователя

                //В запросе есть переменная - cart_items, в которой идет список товаров, разбитый запятой, в формате  [ID товара:количество]
                if ($items = explode(',', waRequest::get('cart_items')))
                {
                    foreach ($items as $item) {
                        $item = trim($item);

                        if (preg_match('~^([0-9]+):([0-9]+)$~ui', $item, $m)) {
                            $correct[$m[1]] = $m[2]; //[ID товара:количество]
                        }
                    }

                    if ($correct)
                    {

                        if (!defined('PLT_UPDATE_CART_FROM_LETTER')) {
                            define('PLT_UPDATE_CART_FROM_LETTER', 1);
                        }

                        $product_model = new shopProductModel();

                        $sku_model = new shopProductSkusModel();

                        $in_cart = array();
                        $code = waRequest::cookie('shop_cart');
                        if (!$code) {
                            $code = md5(uniqid(time(), true));
                            // header for IE
                            wa()->getResponse()->addHeader('P3P', 'CP="NOI ADM DEV COM NAV OUR STP"');
                            // set cart cookie
                            wa()->getResponse()->setCookie('shop_cart', $code, time() + 30 * 86400, null, '', false, true);

                        }


                        //смотрим корзину
                        $cart = new shopCart($code);

                        $products_cart_res = $cart->items();

                        //var_dump($products_cart_res); die();

                        foreach ($products_cart_res as $basket_id => $product) {
                            $product_id = $product['product']['id'];

                            if ($product['sku_id'] != $product['product']['sku_id']) $product_id .= 's' . $product['sku_id'];


                            if ($sku = $sku_model->getSku($product['sku_id'])) {
                                $in_cart[$product_id] = array(
                                    'qnt' => $product['quantity'],
                                    'basket_id' => $basket_id
                                );
                            }
                        }


                        foreach ($correct as $product_id => $qnt) {

                            if (empty($in_cart[$product_id])) {

                                //Нет товара
                                if ($new_product = $product_model->getByField('id', (int)$product_id)) {

                                    $new_cart_item = array(
                                        'product_id' => $product_id,
                                        'sku_id' => $new_product['sku_id'],
                                        'quantity' => (int)$qnt,
                                        'type' => 'product',
                                    );


                                    try {
                                        $cart->addItem($new_cart_item);
                                    } catch (\Exception $e) {

                                    }

                                }


                            } elseif ($in_cart[$product_id]['qnt'] < $qnt) {

                                //var_dump($product_id, $qnt); die();
                                //Корректируем количество
                                try {
                                    $cart->setQuantity($in_cart[$product_id]['basket_id'], (int)$qnt);
                                } catch (Exception $e) {
                                    //var_dump($e->getMessage());
                                }


                            }
                        }

                        wa()->getResponse()->redirect($this->getCartUrl(), 302);
                    }

                }


            }
        }
    }


    public function getCartUrl()
    {
        $url = false;

        if ($route = wa()->getRouting()->getByApp('shop', waRequest::server('HTTP_HOST'))) {
            $route = array_pop($route);
            $url = $route['url'];
            $url = '/' . str_replace('*', '', $url);
            $url = $url . '/cart';
            $url = preg_replace('~\/+~', '/', $url);
            $url = preg_replace('~\/$~ui', '', $url);
        }

        return $url;
    }




    /*
     * Функция добавления контакта полученного из виджетов ProdaLet в адресную книгу магазина
     * ожидаемые данные в запросе
     * переменная в запросе "key" - project id = API KEY
     * в переменной запроса "data" ищем поле "email" - это и есть контакт
     * "token" - подпись запроса
     */
    public function addContactFromProdalet($method)
    {
        if (!($tracker = $this->__add_tracker())) return false;
        //add contact collected by prodalet
        $keys = $this->_get_app_key();

        if ($tracker->checkApiRequest(waRequest::request(), $keys)) {

            $req_data = waRequest::request('data');

            if (!empty($req_data) && !empty($req_data['email'])) {
                $contactEmails = new waContactEmailsModel();
                if (!$contact_id = $contactEmails->getContactIdByEmail($req_data['email'])) {
                    //ok, adding email
                    $contact = new waContact();
                    $contact->add('email', $req_data['email']);
                    return $contact->save();
                }
            }
        }

        return false;

    }


    /*
     * Функция обработки перехода по всем URL в CMS
     */
    public function routing($route = array())
    {
        $uri = waRequest::server('REQUEST_URI');
        $req = new waRequest();
        $method = 'http';

        if ($req->isHttps()) {
            $method = 'https';
        }

        //если в урл есть shop/plt-add-contact - Это значит пришел контакт, на добавление в адресную книгу CMS
        // от ProdaLet, который ввели в каком либо виджете ProdaLet
        if (preg_match('~^\/shop\/plt-add-contact~u', $uri)) {
            $res = $this->addContactFromProdalet();
            $url = $method . '://' . waRequest::server('HTTP_HOST');
            wa()->getResponse()->redirect($url, 302);
            return true;
        }


        //Если в урл есть add - значит вызываем функцию обновления корзины
        $req_post_product_id = waRequest::post('product_id');
        if (strpos($uri, 'add') !== false && !empty($req_post_product_id)) {
            $this->update_cart(array('cart_add' => true, 'product_id' => intval($req_post_product_id)));
        }

        $req_post_quantity = waRequest::post('quantity');
        $req_post_id = waRequest::post('id');
        //Если в урл есть save - значит вызываем функцию обновления корзины
        if ((strpos($uri, 'save') !== false) and (!empty($req_post_quantity)) && (!empty($req_post_id))) {
            $this->update_cart(array('cart_set_quantity' => true, 'id' => intval($req_post_id), 'quantity' => intval($req_post_quantity)));
        }
        $get = $req->get();

        //Смотрим, что клиент перешел по нашей ссылке - что бы продолжить оформление заказа из брошенной корзины
        //Может быть переход из письма или из рекламы
        if (!empty($get['utm_source']) && ($get['utm_source'] == 'prodalet') && !empty($get['cart_items'])) {
            //Это возврат брошеной корзины
            //Значит надо перенаправить посетителя сразу на страницу оформления заказ -
            // и уже там проверить - если корзины нету, то попробовать восстановить ее из данных в ссылке

            //Ищем URL корзины
            $url = false;

            if ($url = $this->getCartUrl()) {

                $current_url = preg_replace("~\?.+$~ui", '', waRequest::server('REQUEST_URI'));
                $current_url = preg_replace('~\/$~ui', '', $current_url);

                if ($current_url != $url) {

                    if ($query = http_build_query($get)) {
                        $url .= '/?' . $query;
                    }

                    $url = $method . '://' . waRequest::server('HTTP_HOST') . $url;//."?test=1";

                    $url = urldecode($url);

                    wa()->getResponse()->redirect($url, 302);
                    return true;


                }

            }
        }


        if (strpos($uri, '/cart') !== false) {
            $this->setCart();
        }


    }


    public function update_cart($params = array())
    {
        if (!($tracker = $this->__add_tracker()) or !class_exists('shopCart')) return false;


        $cart = new shopCart();
        $products_cart_res = $cart->items();


        // fix old cart value
        if (!empty($params['cart_add'])) {
            $find_id = false;
            foreach ($products_cart_res as $id => $product) {
                $rek_sku_id = waRequest::request('sku_id');
                if ((empty($rek_sku_id) and $product['sku_id'] == $params['product_id']) or (!empty($rek_sku_id) and $product['sku_id'] == $rek_sku_id)) {
                    $find_id = $id;
                    break;
                }
            }
            if ($find_id) {
                $products_cart_res[$find_id]['quantity']++;
            }
        }
        if (!empty($params['cart_set_quantity'])) {
            if (isset($products_cart_res[$params['id']])) $products_cart_res[$params['id']]['quantity'] = $params['quantity'];
        }

        $method = null;


        $sku_model = new shopProductSkusModel();

        $products_cart = array();
        foreach ($products_cart_res as $product) {
            $product_id = $product['product']['id'];


            if ($product['sku_id'] != $product['product']['sku_id']) $product_id .= 's' . $product['sku_id'];

            $sku = $sku_model->getSku($product['sku_id']);

            //$productObj = new shopProduct($product_id);
            //$productObj->getProductUrl(true)

            if ($sku) $products_cart[] = array(
                'product_id' => $product_id,
                'qnt' => $product['quantity'],
                'price' => $sku['primary_price'],
                'product_name' => $product['product']['name'],
                'product_img' => $this->getProductImage($product_id),
                //'product_url' => $productURl,
            );
        }


        $tracker->eventUpdateCart($products_cart);
    }

    /*
     * Ищем последние заказы за 90 дней и передаем их в ProdaLet
     */
    public function addLastOrder($k, $s) {
        if (!($tracker = $this->__add_tracker())) return false;

        $order_model = new shopOrderModel();
        $current_date = date("Y-m-d",strtotime("-90 day"));

        $orders = $order_model->select("id")
            ->where("create_datetime >= '".$order_model->escape($current_date)."%'")
            ->fetchALL();


        $return = false;
        foreach ($orders as $order) {
           if($this->purchase(array('order_id' => $order['id']))) {
               $return = true;
           }
        }

        return $return;

    }

    /*
     * Функция передачи адреса страницы корзины  в ProdaLet
     */
    public function setCartUrl($k, $s)
    {
        $cartUrl = $this->getCartUrl();
        if (!($tracker = $this->__add_tracker())) return false;

        return $tracker->eventSetCartUrl($k, $s, $cartUrl);
    }

    /*
     * Функция, говорящая, что наш плагин был установлен и на этом сайте
     */
    public function pingCMS($k, $s)
    {
        if (!($tracker = $this->__add_tracker())) return false;

        return $tracker->eventPingCms($k, $s);
    }


    public function checkout($params)
    {

        if ($params['step'] != 'contactinfo') return '';
        if (!($tracker = $this->__add_tracker())) return '';

        if (!empty($tracker->visitor_uid)) return '';

        //Устанавливаем в нашу переменную
        $res = '<script>var PLT_WA_GUEST_UID="' . $tracker->guest_uid . '"</script>';


        return $res;


    }

    /*
     * Вызывается когда заказ офрмлен
     */
    public function purchase($params = array())
    {

        if (!($order_data = $this->_getOrderData($params['order_id']))) return false;

        $customer = new waContact($order_data->order['contact_id']);


        $req_customer_id = waRequest::request('customer_id');

        if (!empty($req_customer_id)) {
            $req_customer = waRequest::request('customer');

            $fields = array(
                'first_name' => (!empty($req_customer['firstname']) ? $req_customer['firstname'] : false),
                'last_name' => (!empty($req_customer['lastname']) ? $req_customer['lastname'] : false),
                'phone' => (!empty($req_customer['phone']) ? $req_customer['phone'] : false),
                'email' => (!empty($req_customer['email']) ? $req_customer['email'] : false),

            );

        } else {

            $fields = array(
                'first_name' => $customer->get('firstname'),
                'last_name' => $customer->get('lastname'),
                'phone' => (($phone = $customer->get('phone') and isset($phone[0])) ? $phone[0]['value'] : false),
                'email' => (($email = $customer->get('email') and isset($email[0])) ? $email[0]['value'] : false),

            );

        }

        $this->visitor_info = array();
        foreach ($fields as $key => $value) {
            if ($value) $this->visitor_info[$key] = $value;
        }

        if (!($tracker = $this->__add_tracker())) return false;

        return $tracker->eventOrder($order_data->order_id, $order_data->revenue, $order_data->items, $order_data->state);
    }


    /*
     * Вставка нашего объекта в Head блок страниц магазина
     */
    public function frontendHead()
    {
        $cart = new shopCart();
        $products_cart_res = $cart->items();

        $contact_id = 0;
        $customer_fields_text = '';

        $custom= '';
        if(!empty($products_cart_res)) {
            foreach ($products_cart_res as $id => $product) {
                $custom .= "[{$product['name']} - " . number_format($product['price'], 2, ',', ' ') . " руб. - {$product['quantity']}шт.]  ";
                if(isset($product['contact_id']) and !empty($product['contact_id'])) {
                    $contact_id = $product['contact_id'];
                }
            }
        } else {
            $custom= "отсутствует";
        }

        if($contact_id) {
            $customer = new waContact($contact_id);
            $customer_fields = array(
                'name' => $customer->get('firstname') . ' ' .$customer->get('lastname'),
                'phone' => (($phone = $customer->get('phone') and isset($phone[0])) ? $phone[0]['value'] : false),
                'email' => (($email = $customer->get('email') and isset($email[0])) ? $email[0]['value'] : false),
            );
            $customer_fields_text = "
                name: '{$customer_fields['name']}',
	            phone: '{$customer_fields['phone']}',
	            email: '{$customer_fields['email']}',
	            clientId: '{$contact_id}',
            ";
        }

        $res = " <script>
        var pltClientInfo = {
            {$customer_fields_text}
            custom: {
                'Корзина клиента': '{$custom}'
            }
        }
        </script>";


        $res2 =  self::widget();

        return $res2.$res;
    }

    public function view_product($params = array())
    {
        return array(
            'cart'      => '<span id="prodalet_after_cart"></span>',
        );
    }


    /*
     * На каждой странице выводим JS код плагина ProdaLet
     */
    public static function widget()
    {
        //Если $api_key не настроен в админке, то ничего не делаем
        if (!($api_key = self::_get_app_key())) return false;


        $js_client_info_query = '';
        //Если пользователь авторизован в CMS
        if ($user_id = wa()->getUser()->getId()) {
            $js_client_info = array(
                'first_name' => wa()->getUser()->get('firstname', 'default'),
                'last_name' => wa()->getUser()->get('lastname', 'default'),
                'phone' => wa()->getUser()->get('phone', 'default'),
                'email' => wa()->getUser()->get('email', 'default'),
                'client_id' => $user_id,
                'guest_id' => ""
            );


        } else {
            //Если пользователь неизвестен
            $js_client_info = array(
                'first_name' => "",
                'last_name' => "",
                'phone' => "",
                'email' => "",
                'client_id' => "",
                'guest_id' => ""
            );
        }

        $js_client_info = json_encode($js_client_info);
        $js_client_info_query = "PLTQ.push(['api', 'setClientInfo', " . $js_client_info . "]);";


        $product_model = new shopProductModel();
        $product = $product_model->getByField('url', waRequest::param('product_url'));
        $js_ready = '';


        if ($product) {
            $image = '';
            if ($url = self::getProductImage($product['id'])) {
                $image = ',product_img: \'' . $url . '\'';
            }


            $js_ready = "
				PLTQ.push(['api', 'productView', {product:{
					product_id: '{$product["id"]}',
					product_name: '{$product["name"]}',
					product_url: window.location.href" . $image . "
				  }}
				  ]);
			";
        }


        //$js_ready = ''; //временно

        $host = self::getProdaletUrl();

        //Если указана задержка загрузки нашего скрипта
        $lazy_load_time = 0;
        if(!empty($api_key['lazy_load'])) {
            $lazy_load_time = 1000 * floatval($api_key['lazy_load']);
        }


        //Формируем код для встраивания в страницу
        $ret = "
<!--Start Prodalet code WA plugin vers 2.1.0 {literal}-->
<script>
    setTimeout(function (){ 
        var PLTQ = []; {$js_client_info_query} var d = new Date().getTime();
        
        (function (d,w) { 
            var n = d.getElementsByTagName(\"script\")[0], 
            s = d.createElement(\"script\"), 
            f = function () { n.parentNode.insertBefore(s, n); }; 
            var dt = new Date().getTime(); 
            s.type = \"text/javascript\"; 
            s.id=\"plt_main\"; 
            s.src=\"{$host}/bundles/api/main.js?h=\"+dt; 
            s.setAttribute(\"data-plugin\", \"wa\"); 
            s.setAttribute(\"data-pltkey\", \"{$api_key['api_key']}\"); 
            s.setAttribute(\"data-plthost\",\"{$host}\"); 
            s.async = true; 
            if (w.opera == \"[object Opera]\") { 
                d.addEventListener(\"DOMContentLoaded\", f, false); 
            } else { 
                f(); 
            } })(document,window);{$js_ready}
            
        
        //document.write('<scr'+'ipt src=\"{$host}/bundles/api/main.js?h='+d+'\" data-plugin=\"wa\" data-pltkey=\"{$api_key['api_key']}\" data-plthost=\"{$host}\" async=\"async\"></scr'+'ipt>');{$js_ready}
    }
        
    ,{$lazy_load_time});</script>
<!--End Prodalet code {/literal}-->";


        return $ret;
    }

    private function _getOrderData($order_id)
    {

        $order_model = new shopOrderModel();
        $order = $order_model->getById($order_id);

        if (!$order) return false;

        $order_items_model = new shopOrderItemsModel();
        $items_res = $order_items_model->getByField('order_id', $order_id, true);
        $items = array();
        //$sku_model = new shopProductSkusModel();
        $ret = new stdClass();
        foreach ($items_res as $product) {
            //$skus = $sku_model->getDataByProductId($product['product_id']);
            //$prM = $productModel->getById($product['product_id']);
            $productObj = new shopProduct($product['product_id']);
            //$productData = $productObj->getData();

            //$product['product'] = $skus[$product['sku_id']];
            $product_id = $product['product_id'];
            //if ($product['sku_id'] != $product['product']['id']) $product_id .= 's' . $product['sku_id'];

            $items[] = array(
                'product_id' => $product_id,
                'qnt' => $product['quantity'],
                'price' => $product['price'],
                'product_name' => $product['name'],
                'product_img' => $this->getProductImage($product_id),
                'product_url' => $productObj->getProductUrl(),
            );
        }
        $ret->order_id = $order_id;
        $ret->items = $items;
        $ret->revenue = $order['total'];
        $ret->state = $this->_changeStatus($order['state_id']);
        $ret->order = $order;
        return $ret;
    }

    private function _changeStatus($state)
    {
        switch ($state) {
            case 'processing':
                $state = 'new';
                break;
            case 'paid':
                $state = 'paid';
                break;
            case 'shipped':
                $state = 'shipped';
                break;
        }
        return $state;
    }


    private function __add_tracker_wu()
    {
        if (!($api_key = self::_get_app_key())) {
            return false;
        }

        $tracker = new ProdaletTracker($api_key);

        return $tracker;
    }

    private function __add_tracker()
    {
        if (!($api_key = self::_get_app_key())) return false;


        $auth = new waAuth();

        $rek_customer_id = waRequest::request('customer_id');
        if (!empty($rek_customer_id)) {
            // create purchase from admin panel without customer
            $guest_uid = ($rek_customer_id == 0 ? uniqid() : false);
            $uid = ($rek_customer_id == 0 ? false : $rek_customer_id);
        } else {
            $guest_uid = waRequest::cookie('PLT_VID');
            $uid = (($auth_info = $auth->isAuth()) ? $auth_info['id'] : false);
        }

        $routing = wa()->getRouting();
        $domain = $routing->getDomain();


        //$tracker = new ProdaletTracker($api_key, waRequest::server('SERVER_NAME'), $guest_uid, $uid, (isset($this->visitor_info) ? $this->visitor_info : false));
        $tracker = new ProdaletTracker($api_key, $domain, $guest_uid, $uid, (isset($this->visitor_info) ? $this->visitor_info : false));

        return $tracker;
    }

    /*
     * Получаем API KEY из настроек магазина для текущего домена
     */
    public static function _get_app_key()
    {
        $plugin = wa('shop')->getPlugin('prodalet');
        $settings = $plugin->getSettings();

        $return = array();

        wa('site');
        foreach (siteHelper::getDomains(true) as $domain_id => $domain) if (waRequest::server('SERVER_NAME') == $domain['name']) break;
        if (isset($settings['options']) && isset($settings['options']['domains'])
            && !empty($settings['options']['domains'][$domain_id])
            && !empty($settings['options']['domains'][$domain_id]['api_key'])) {

            if (!empty($settings['options']['domains'][$domain_id]['api_secret'])) {
                $return['api_key'] = $settings['options']['domains'][$domain_id]['api_key'];
                $return['api_secret'] = $settings['options']['domains'][$domain_id]['api_secret'];

                if(!empty($settings['options']['domains'][$domain_id]['lazy_load'])) {
                    $return['lazy_load'] = $settings['options']['domains'][$domain_id]['lazy_load'];
                }
                return $return;

            }


        } elseif (!empty($settings['options']['api_key']) && !empty($settings['options']['api_secret'])) {

            $return['api_key'] = $settings['options']['api_key'];
            $return['api_secret'] = $settings['options']['api_secret'];

            if(!empty($settings['options']['lazy_load'])) {
                $return['lazy_load'] = $settings['options']['lazy_load'];
            }
            return $return;

            //return [$settings['options']['api_key'], $settings['options']['api_secret']];
        } else return false;
    }

}
